﻿using CoreModels.Enums.Department;
using CoreModels.Tools;
using ModuleTools.Attributes;
using System;

namespace CoreModels.ModelsDepartment
{
    [EntityDescription("Classroom", "Аудитрия кафедры")]
    [EntityDependency("Employee", "EmployeeId", "Сотрудник, отвечающий за аудиторию")]
    public interface IClassroomModel : IId
    {
        string Number { get; }

        string Title { get; }

        Guid EmployeeId { get; }

        ClassroomType ClassroomType { get; }

        decimal Square { get; }

        int Capacity { get; }

        string SecurityCode { get; }

        bool HaveProjector { get; }

        string Description { get; }

        byte[] Photo { get; }
    }
}