﻿using Microsoft.EntityFrameworkCore.Migrations;

namespace DatabaseCore.Migrations
{
    public partial class UpdUniqueTimeNorm : Migration
    {
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_AcademicPlanRecordTimeNormHours_TimeNorms_TimeNormId",
                table: "AcademicPlanRecordTimeNormHours");

            migrationBuilder.DropIndex(
                name: "IX_TimeNorms_TimeNormName",
                table: "TimeNorms");

            migrationBuilder.AlterColumn<string>(
                name: "TimeNormShortName",
                table: "TimeNorms",
                type: "nvarchar(450)",
                nullable: false,
                oldClrType: typeof(string),
                oldType: "nvarchar(max)");

            migrationBuilder.CreateIndex(
                name: "IX_TimeNorms_TimeNormName_TimeNormShortName",
                table: "TimeNorms",
                columns: new[] { "TimeNormName", "TimeNormShortName" },
                unique: true);

            migrationBuilder.AddForeignKey(
                name: "FK_AcademicPlanRecordTimeNormHours_TimeNorms_TimeNormId",
                table: "AcademicPlanRecordTimeNormHours",
                column: "TimeNormId",
                principalTable: "TimeNorms",
                principalColumn: "Id",
                onDelete: ReferentialAction.NoAction);
        }

        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_AcademicPlanRecordTimeNormHours_TimeNorms_TimeNormId",
                table: "AcademicPlanRecordTimeNormHours");

            migrationBuilder.DropIndex(
                name: "IX_TimeNorms_TimeNormName_TimeNormShortName",
                table: "TimeNorms");

            migrationBuilder.AlterColumn<string>(
                name: "TimeNormShortName",
                table: "TimeNorms",
                type: "nvarchar(max)",
                nullable: false,
                oldClrType: typeof(string),
                oldType: "nvarchar(450)");

            migrationBuilder.CreateIndex(
                name: "IX_TimeNorms_TimeNormName",
                table: "TimeNorms",
                column: "TimeNormName",
                unique: true);

            migrationBuilder.AddForeignKey(
                name: "FK_AcademicPlanRecordTimeNormHours_TimeNorms_TimeNormId",
                table: "AcademicPlanRecordTimeNormHours",
                column: "TimeNormId",
                principalTable: "TimeNorms",
                principalColumn: "Id");
        }
    }
}
