﻿using System;
using Microsoft.EntityFrameworkCore.Migrations;

namespace DatabaseCore.Migrations
{
    public partial class ChangeAcademPlan : Migration
    {
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_AcademicPlanRecordTimeNormHours_TimeNorms_TimeNormId",
                table: "AcademicPlanRecordTimeNormHours");

            migrationBuilder.DropForeignKey(
                name: "FK_AcademicPlans_EducationDirections_EducationDirectionId",
                table: "AcademicPlans");

            migrationBuilder.DropIndex(
                name: "IX_AcademicPlans_EducationDirectionId_YearEntrance",
                table: "AcademicPlans");

            migrationBuilder.AlterColumn<Guid>(
                name: "EducationDirectionId",
                table: "AcademicPlans",
                type: "uniqueidentifier",
                nullable: true,
                oldClrType: typeof(Guid),
                oldType: "uniqueidentifier");

            migrationBuilder.CreateIndex(
                name: "IX_AcademicPlans_EducationDirectionId_YearEntrance",
                table: "AcademicPlans",
                columns: new[] { "EducationDirectionId", "YearEntrance" },
                unique: true,
                filter: "[EducationDirectionId] IS NOT NULL");

            migrationBuilder.AddForeignKey(
                name: "FK_AcademicPlanRecordTimeNormHours_TimeNorms_TimeNormId",
                table: "AcademicPlanRecordTimeNormHours",
                column: "TimeNormId",
                principalTable: "TimeNorms",
                principalColumn: "Id",
                onDelete: ReferentialAction.NoAction);

            migrationBuilder.AddForeignKey(
                name: "FK_AcademicPlans_EducationDirections_EducationDirectionId",
                table: "AcademicPlans",
                column: "EducationDirectionId",
                principalTable: "EducationDirections",
                principalColumn: "Id",
                onDelete: ReferentialAction.Restrict);
        }

        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_AcademicPlanRecordTimeNormHours_TimeNorms_TimeNormId",
                table: "AcademicPlanRecordTimeNormHours");

            migrationBuilder.DropForeignKey(
                name: "FK_AcademicPlans_EducationDirections_EducationDirectionId",
                table: "AcademicPlans");

            migrationBuilder.DropIndex(
                name: "IX_AcademicPlans_EducationDirectionId_YearEntrance",
                table: "AcademicPlans");

            migrationBuilder.AlterColumn<Guid>(
                name: "EducationDirectionId",
                table: "AcademicPlans",
                type: "uniqueidentifier",
                nullable: false,
                defaultValue: new Guid("00000000-0000-0000-0000-000000000000"),
                oldClrType: typeof(Guid),
                oldType: "uniqueidentifier",
                oldNullable: true);

            migrationBuilder.CreateIndex(
                name: "IX_AcademicPlans_EducationDirectionId_YearEntrance",
                table: "AcademicPlans",
                columns: new[] { "EducationDirectionId", "YearEntrance" },
                unique: true);

            migrationBuilder.AddForeignKey(
                name: "FK_AcademicPlanRecordTimeNormHours_TimeNorms_TimeNormId",
                table: "AcademicPlanRecordTimeNormHours",
                column: "TimeNormId",
                principalTable: "TimeNorms",
                principalColumn: "Id");

            migrationBuilder.AddForeignKey(
                name: "FK_AcademicPlans_EducationDirections_EducationDirectionId",
                table: "AcademicPlans",
                column: "EducationDirectionId",
                principalTable: "EducationDirections",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);
        }
    }
}
