﻿using Microsoft.EntityFrameworkCore.Migrations;

namespace DatabaseCore.Migrations
{
    public partial class ChangeStudentGroups : Migration
    {
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_StudentGroups_AcademicPlans_AcademicPlanId",
                table: "StudentGroups");

            migrationBuilder.RenameColumn(
                name: "EnrollmentYear",
                table: "StudentGroups",
                newName: "AcademicCourse");

            migrationBuilder.RenameColumn(
                name: "AcademicPlanId",
                table: "StudentGroups",
                newName: "EducationDirectionId");

            migrationBuilder.RenameIndex(
                name: "IX_StudentGroups_AcademicPlanId_EnrollmentYear_GroupNumber",
                table: "StudentGroups",
                newName: "IX_StudentGroups_EducationDirectionId_AcademicCourse_GroupNumber");

            migrationBuilder.AddForeignKey(
                name: "FK_StudentGroups_EducationDirections_EducationDirectionId",
                table: "StudentGroups",
                column: "EducationDirectionId",
                principalTable: "EducationDirections",
                principalColumn: "Id",
                onDelete: ReferentialAction.NoAction);
        }

        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_StudentGroups_EducationDirections_EducationDirectionId",
                table: "StudentGroups");

            migrationBuilder.RenameColumn(
                name: "EducationDirectionId",
                table: "StudentGroups",
                newName: "AcademicPlanId");

            migrationBuilder.RenameColumn(
                name: "AcademicCourse",
                table: "StudentGroups",
                newName: "EnrollmentYear");

            migrationBuilder.RenameIndex(
                name: "IX_StudentGroups_EducationDirectionId_AcademicCourse_GroupNumber",
                table: "StudentGroups",
                newName: "IX_StudentGroups_AcademicPlanId_EnrollmentYear_GroupNumber");

            migrationBuilder.AddForeignKey(
                name: "FK_StudentGroups_AcademicPlans_AcademicPlanId",
                table: "StudentGroups",
                column: "AcademicPlanId",
                principalTable: "AcademicPlans",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);
        }
    }
}
