﻿using CoreModels.ModelsDepartment;
using ModuleTools.Interfaces;
using System;
using System.ComponentModel.DataAnnotations;
using System.Runtime.Serialization;

namespace DatabaseCore.Models.Department
{
    [DataContract]
	public class AcademicPlanRecordTimeNormHour : BaseEntity, IEntitySecurityExtenstion<AcademicPlanRecordTimeNormHour>, IAcademicPlanRecordTimeNormHourModel
	{
		[DataMember]
		[Required(ErrorMessage = "required")]
		public Guid AcademicPlanRecordId { get; set; }

		[DataMember]
		[Required(ErrorMessage = "required")]
		public Guid TimeNormId { get; set; }

		[DataMember]
		[Required(ErrorMessage = "required")]
		public decimal PlanHours { get; set; }

		//-------------------------------------------------------------------------

		public virtual AcademicPlanRecord AcademicPlanRecord { get; set; }

		public virtual TimeNorm TimeNorm { get; set; }

		//-------------------------------------------------------------------------

		//-------------------------------------------------------------------------

		public AcademicPlanRecordTimeNormHour SecurityCheck(AcademicPlanRecordTimeNormHour entity, bool allowFullData) => entity;

		public override string ToString() => $"{AcademicPlanRecord.Discipline}({(AcademicPlanRecord.Semester + 1)}) - {TimeNorm}";
	}
}