﻿using CoreModels.Enums.Department;
using CoreModels.ModelsDepartment;
using ModuleTools.Interfaces;
using System;
using System.ComponentModel.DataAnnotations;
using System.Runtime.Serialization;

namespace DatabaseCore.Models.Department
{
    [DataContract]
	public class Classroom : BaseEntity, IEntitySecurityExtenstion<Classroom>, IClassroomModel
	{
		[DataMember]
		[Required(ErrorMessage = "required")]
		public string Number { get; set; }

		[DataMember]
		public string Title { get; set; }

		[DataMember]
		[Required(ErrorMessage = "required")]
		public Guid EmployeeId { get; set; }

		[DataMember]
		[Required(ErrorMessage = "required")]
		public ClassroomType ClassroomType { get; set; }

		[DataMember]
		[Required(ErrorMessage = "required")]
		public decimal Square { get; set; }

		[DataMember]
		[Required(ErrorMessage = "required")]
		public int Capacity { get; set; }

		[DataMember]
		public string SecurityCode { get; set; }

		[DataMember]
		public bool HaveProjector { get; set; }

		[DataMember]
		public string Description { get; set; }

		[DataMember]
		public byte[] Photo { get; set; }

		//-------------------------------------------------------------------------

		public virtual Employee Employee { get; set; }

		//-------------------------------------------------------------------------

		//-------------------------------------------------------------------------

		public Classroom SecurityCheck(Classroom entity, bool allowFullData)
		{
			if (!allowFullData)
			{
				entity.SecurityCode = "скрыто";
			}

			return entity;
		}

		public override string ToString() => Number;
	}
}