﻿using CoreModels.ModelsDepartment;
using ModuleTools.Interfaces;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Runtime.Serialization;

namespace DatabaseCore.Models.Department
{
    [DataContract]
	public class DisciplineBlock : BaseEntity, IEntitySecurityExtenstion<DisciplineBlock>, IDisciplineBlockModel
    {
        [DataMember]
        [Required(ErrorMessage = "required")]
        public string Title { get; set; }

        [DataMember]
        public bool DisciplineBlockUseForGrouping { get; set; }

        [DataMember]
        public int DisciplineBlockOrder { get; set; }

        [DataMember]
        public string DisciplineBlockBlueAsteriskName { get; set; }

        //-------------------------------------------------------------------------

        //-------------------------------------------------------------------------

        [ForeignKey("DisciplineBlockId")]
        public virtual List<Discipline> Disciplines { get; set; }

        [ForeignKey("DisciplineBlockId")]
        public virtual List<TimeNorm> TimeNorms { get; set; }

        //-------------------------------------------------------------------------

        public DisciplineBlock SecurityCheck(DisciplineBlock entity, bool allowFullData) => entity;

        public override string ToString() => Title;
    }
}