﻿using ModuleTools.Attributes;
using ModuleTools.Interfaces;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Runtime.Serialization;

namespace DatabaseCore.Models.Department
{
	/// <summary>
	/// Класс, описывающий ученое звание преподавателя кафедры
	/// </summary>
	[DataContract]
	[EntityDescription("LecturerAcademicRank", "Ученое звание преподавателя кафедры")]
	public class LecturerAcademicRank : BaseEntity, IEntitySecurityExtenstion<LecturerAcademicRank>
	{
		[DataMember]
		[Required]
		[MapConfiguration("LecturerAcademicRankName")]
		public string LecturerAcademicRankName { get; set; }

		[DataMember]
		[MapConfiguration("Order")]
		public int Order { get; set; }

		//-------------------------------------------------------------------------

		//-------------------------------------------------------------------------

		[ForeignKey("LecturerAcademicRankId")]
		public virtual List<Lecturer> Lecturers { get; set; }

		//-------------------------------------------------------------------------

		public LecturerAcademicRank SecurityCheck(LecturerAcademicRank entity, bool allowFullData) => entity;

		public override string ToString() => LecturerAcademicRankName;
	}
}