﻿using ModuleTools.Attributes;
using ModuleTools.Interfaces;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Runtime.Serialization;

namespace DatabaseCore.Models.Department
{
	/// <summary>
	/// Класс, описывающий историю синхронизации приказов
	/// </summary>
	[DataContract]
	[EntityDescription("OrderSyncHistory", "История синхронизации приказов")]
	public class OrderSyncHistory : IdEntity, IEntitySecurityExtenstion<OrderSyncHistory>
    {
        [DataMember]
        [Required(ErrorMessage = "required")]
        [MapConfiguration("SyncDate")]
        public DateTime SyncDate { get; set; }

        //-------------------------------------------------------------------------

        //-------------------------------------------------------------------------

        [ForeignKey("OrderSyncHistoryId")]
        public virtual List<OrderSyncHistoryRecord> OrderSyncHistoryRecords { get; set; }

        //-------------------------------------------------------------------------

        public OrderSyncHistory SecurityCheck(OrderSyncHistory entity, bool allowFullData) => entity;

        public override string ToString() => SyncDate.ToShortDateString();
    }
}