﻿using ModuleTools.Attributes;
using ModuleTools.Interfaces;
using System;
using System.ComponentModel.DataAnnotations;
using System.Runtime.Serialization;

namespace DatabaseCore.Models.Department
{
	/// <summary>
	/// Класс, описывающий запись истории синхронизации приказов
	/// </summary>
	[DataContract]
	[EntityDescription("OrderSyncHistoryRecord", "Дисципилна кафедры")]
	[EntityDependency("OrderSyncHistory", "OrderSyncHistoryId", "История синхронизации прказов, к которой относитя запись")]
	public class OrderSyncHistoryRecord : IdEntity, IEntitySecurityExtenstion<OrderSyncHistoryRecord>
    {
        [DataMember]
		[Required(ErrorMessage = "required")]
		[MapConfiguration("OrderSyncHistoryId")]
		public Guid OrderSyncHistoryId { get; set; }

		[DataMember]
		[Required(ErrorMessage = "required")]
		[MapConfiguration("Information")]
		public string Information { get; set; }

		//-------------------------------------------------------------------------

		public virtual OrderSyncHistory OrderSyncHistory { get; set; }

        //-------------------------------------------------------------------------

        //-------------------------------------------------------------------------

        public OrderSyncHistoryRecord SecurityCheck(OrderSyncHistoryRecord entity, bool allowFullData)
        {
            if (!allowFullData)
            {
                entity.Information = "скрыто";
            }

            return entity;
        }

        public override string ToString() => Information;
    }
}
