﻿using CoreModels.ModelsDepartment;
using ModuleTools.BindingModels;
using System;
using System.ComponentModel.DataAnnotations;

namespace DepartmentBusinessLogic.BindingModels
{
    /// <summary>
    /// Получение учебного года
    /// </summary>
    public class AcademicPlanGetBindingModel : GetBindingModel
	{
		public Guid? EducationDirectionId { get; set; }
	}

	/// <summary>
	/// Сохранение учебного года
	/// </summary>
	public class AcademicPlanSetBindingModel : SetBindingModel, IAcademicPlanModel
	{
		public Guid? EducationDirectionId { get; set; }

		[Required(ErrorMessage = "required")]
		public int YearEntrance { get; set; }

		[Required(ErrorMessage = "required")]
		public int YearFinish { get; set; }
	}

	/// <summary>
	/// Модель для зазгрузки планов
	/// </summary>
	public class AcademicPlanLoadPlxModel
	{
		public Guid AcademicPlanId { get; set; }

		public string FileName { get; set; }
	}
}