﻿using ModuleTools.Attributes;
using ModuleTools.BindingModels;
using System;
using System.ComponentModel.DataAnnotations;

namespace DepartmentBusinessLogic.BindingModels
{
	/// <summary>
	/// Получение записи истории синхронизации приказов
	/// </summary>
	public class OrderSyncHistoryRecordGetBindingModel : GetBindingModel
	{
		public Guid? OrderSyncHistoryId { get; set; }
	}

	/// <summary>
	/// Сохранение записи истории синхронизации приказов
	/// </summary>
	public class OrderSyncHistoryRecordSetBindingModel : SetBindingModel
	{
		[Required(ErrorMessage = "required")]
		[MapConfiguration("OrderSyncHistoryId")]
		public Guid OrderSyncHistoryId { get; set; }

		[Required(ErrorMessage = "required")]
		[MapConfiguration("Information")]
		public string Information { get; set; }
	}
}