﻿using CoreModels.Enums.Department;
using ModuleTools.Attributes;
using ModuleTools.BindingModels;
using System;
using System.ComponentModel.DataAnnotations;

namespace DepartmentBusinessLogic.BindingModels
{
    /// <summary>
    /// Получение нормы времени
    /// </summary>
	public class TimeNormGetBindingModel : GetBindingModel
    {
        public Guid? DisciplineBlockId { get; set; }
    }

    /// <summary>
    /// Сохранение нормы времени
    /// </summary>
    public class TimeNormSetBindingModel : SetBindingModel
    {
        [Required(ErrorMessage = "required")]
        [MapConfiguration("DisciplineBlockId")]
        public Guid DisciplineBlockId { get; set; }

        [Required(ErrorMessage = "required")]
        [MapConfiguration("TimeNormName")]
        public string TimeNormName { get; set; }

        [Required(ErrorMessage = "required")]
        [MapConfiguration("TimeNormShortName")]
        public string TimeNormShortName { get; set; }

        [Required(ErrorMessage = "required")]
        [MapConfiguration("TimeNormOrder")]
        public int TimeNormOrder { get; set; }

        [MapConfiguration("TimeNormEducationDirectionQualification")]
        public EducationDirectionQualification? TimeNormEducationDirectionQualification { get; set; }

        [Required(ErrorMessage = "required")]
        [MapConfiguration("KindOfLoadName")]
        public string KindOfLoadName { get; set; }

        [MapConfiguration("KindOfLoadAttributeName")]
        public string KindOfLoadAttributeName { get; set; }

        [MapConfiguration("KindOfLoadBlueAsteriskName")]
        public string KindOfLoadBlueAsteriskName { get; set; }

        [MapConfiguration("KindOfLoadBlueAsteriskAttributeName")]
        public string KindOfLoadBlueAsteriskAttributeName { get; set; }

        [MapConfiguration("KindOfLoadBlueAsteriskPracticName")]
        public string KindOfLoadBlueAsteriskPracticName { get; set; }

        [MapConfiguration("UseInLearningProgress")]
        public bool UseInLearningProgress { get; set; }

        [MapConfiguration("UseInSite")]
        public bool UseInSite { get; set; }

        /// <summary>
        /// Код вида работ в справочнике видов работ в новой версии планов, чтобы потом искать работу в строках плана
        /// </summary>
        public string KindOfLoadBlueAsteriskCode { get; set; }

        /// <summary>
        /// Код вида практики в справочнике видов практик в новой версии планов, чтобы потом искать практику в строках плана
        /// </summary>
        public string KindOfLoadBlueAsteriskPracticCode { get; set; }
    }
}