﻿using ModuleTools.Attributes;
using ModuleTools.Enums;
using ModuleTools.ViewModels;

namespace DepartmentBusinessLogic.ViewModels
{
	/// <summary>
	/// Список должностей преподавателей
	/// </summary>
	public class LecturerAcademicDegreeListViewModel : ListViewModel<LecturerAcademicDegreeViewModel> { }

	/// <summary>
	/// Элемент должности преподавателей
	/// </summary>
	[ViewModelControlElementClass(HaveDependenceEntities = true, Width = 800, Height = 500)]
	[ViewModelControlElementDependenceEntity(Title = "Преподаватели", Order = 1, ParentPropertyName = "LecturerAcademicDegreeId",
		ControlTypeObject = "DepartmentWindowsDesktop.EntityControls.ControlLecturerList, DepartmentWindowsDesktop")]
	public class LecturerAcademicDegreeViewModel : ElementViewModel
	{
		[ViewModelControlListProperty("Ученая степень")]
		[ViewModelControlElementProperty("Ученая степень", ControlType.ControlString, MustHaveValue = true)]
		[MapConfiguration("LecturerAcademicDegreeName")]
		public string LecturerAcademicDegreeName { get; set; }

		[ViewModelControlListProperty("Описание")]
		[ViewModelControlElementProperty("Описание", ControlType.ControlString)]
		[MapConfiguration("Description")]
		public string Description { get; set; }

		[ViewModelControlListProperty("Порядок", ColumnWidth = 100)]
		[ViewModelControlElementProperty("Порядок", ControlType.ControlInt, MustHaveValue = true)]
		[MapConfiguration("Order")]
		public int Order { get; set; }
	}
}