﻿using ModuleTools.Attributes;
using ModuleTools.Enums;
using ModuleTools.ViewModels;
using System;

namespace DepartmentBusinessLogic.ViewModels
{
	/// <summary>
	/// Список записей историй синхронизации приказов
	/// </summary>
	public class OrderSyncHistoryRecordListViewModel : ListViewModel<OrderSyncHistoryRecordViewModel> { }

	/// <summary>
	/// Элемент записи историй синхронизации приказов
	/// </summary>
	[ViewModelControlElementClass(HaveDependenceEntities = false, Width = 800, Height = 500)]
	public class OrderSyncHistoryRecordViewModel : ElementViewModel
	{
		[ViewModelControlElementProperty("История", ControlType.ControlGuid, MustHaveValue = true, ReadOnly = false, ControlTypeObject = "DepartmentWindowsDesktop.EntityControls.ControlOrderSyncHistoryList, DepartmentWindowsDesktop")]
		[MapConfiguration("OrderSyncHistoryId")]
		public Guid OrderSyncHistoryId { get; set; }

		[ViewModelControlListProperty("Дата", ColumnWidth = 100, DefaultCellStyleFormat = "dd.MM.yyyy")]
		[MapConfiguration("OrderSyncHistory.SyncDate", IsDifficle = true)]
		public DateTime SyncDate { get; set; }

		[ViewModelControlListProperty("Описание")]
		[ViewModelControlElementProperty("Описание", ControlType.ControlText, Height = 200, MustHaveValue = true)]
		[MapConfiguration("Information")]
		public string Information { get; set; }
	}
}