﻿using DatabaseCore;
using DatabaseCore.Models.Department;
using DepartmentBusinessLogic.BindingModels;
using DepartmentBusinessLogic.Interfaces;
using DepartmentBusinessLogic.ViewModels;
using Microsoft.EntityFrameworkCore;
using ModuleTools.Models;
using System.Linq;

namespace DepartmentDatabaseImplementation.Implementations
{
	/// <summary>
	/// Реализация IAcademicPlanRecordTimeNormHourService
	/// </summary>
	public class AcademicPlanRecordTimeNormHourService :
		AbstractGenerticEntityService<AcademicPlanRecordTimeNormHourGetBindingModel, AcademicPlanRecordTimeNormHourSetBindingModel, AcademicPlanRecordTimeNormHour, AcademicPlanRecordTimeNormHourListViewModel, AcademicPlanRecordTimeNormHourViewModel>,
		IAcademicPlanRecordTimeNormHourService
	{
		protected override OperationResultModel AdditionalCheckingWhenAdding(DbContext context, AcademicPlanRecordTimeNormHourSetBindingModel model) => OperationResultModel.Success(null);

		protected override OperationResultModel AdditionalCheckingWhenDeleting(DbContext context, AcademicPlanRecordTimeNormHour entity, AcademicPlanRecordTimeNormHourGetBindingModel model) => OperationResultModel.Success(null);

		protected override IQueryable<AcademicPlanRecordTimeNormHour> AdditionalCheckingWhenReadingList(IQueryable<AcademicPlanRecordTimeNormHour> query, AcademicPlanRecordTimeNormHourGetBindingModel model)
		{
			if (model.AcademicPlanRecordId.HasValue)
			{
				query = query.Where(x => x.AcademicPlanRecordId == model.AcademicPlanRecordId.Value);
			}
			if (model.TimeNormId.HasValue)
			{
				query = query.Where(x => x.TimeNormId == model.TimeNormId.Value);
			}
			return query;
		}

		protected override OperationResultModel AdditionalCheckingWhenUpdateing(DbContext context, AcademicPlanRecordTimeNormHourSetBindingModel model) => OperationResultModel.Success(null);

		protected override void AdditionalDeleting(DbContext context, AcademicPlanRecordTimeNormHour entity, AcademicPlanRecordTimeNormHourGetBindingModel model) { }

		protected override AcademicPlanRecordTimeNormHour GetUniqueEntity(AcademicPlanRecordTimeNormHourSetBindingModel model, DbContext context) => context.Set<AcademicPlanRecordTimeNormHour>().FirstOrDefault(x => x.AcademicPlanRecordId == model.AcademicPlanRecordId && x.TimeNormId == model.TimeNormId && x.Id != model.Id);

		protected override IQueryable<AcademicPlanRecordTimeNormHour> IncludingWhenReading(IQueryable<AcademicPlanRecordTimeNormHour> query) => query.Include(x => x.AcademicPlanRecord).Include(x => x.AcademicPlanRecord.Discipline).Include(x => x.TimeNorm);

		protected override IQueryable<AcademicPlanRecordTimeNormHour> OrderingWhenReading(IQueryable<AcademicPlanRecordTimeNormHour> query) => query.OrderBy(x => x.AcademicPlanRecord.Semester).ThenBy(x => x.AcademicPlanRecord.Discipline.DisciplineName).ThenBy(x => x.TimeNorm.TimeNormOrder);
	}
}