﻿using CoreModels.ModelsSecurity;
using ModuleTools.BindingModels;
using ModuleTools.Enums;
using System;
using System.ComponentModel.DataAnnotations;

namespace SecurityBusinessLogic.BindingModels
{
    /// <summary>
    /// Получение информации по доступу
    /// </summary>
    public class AccessGetBindingModel : GetBindingModel
	{
		/// <summary>
		/// Для вывода списка доступов по роли в контроле десктопном
		/// </summary>
		public Guid? RoleId { get; set; }
	}

	/// <summary>
	/// Сохранение информации по доступу
	/// </summary>
	public class AccessSetBindingModel : SetBindingModel, IAccessModel
	{
		public Guid RoleId { get; set; }

		[Required(ErrorMessage = "required")]
		public AccessOperation AccessOperation { get; set; }

		public AccessType AccessType { get; set; }
	}
}