﻿using DesktopTools.Controls;
using DesktopTools.Interfaces;
using DesktopTools.Models;
using SecurityBusinessLogic.BindingModels;
using SecurityBusinessLogic.BusinessLogics;
using SecurityBusinessLogic.ViewModels;
using System;

namespace SecurityWindowsDesktop.EntityControls
{
	/// <summary>
	/// Реализация контрола для связи сотрудника с ролью
	/// </summary>
	public partial class ControlUserRoleElement : 
		GenericControlEntityElement<UserRoleGetBindingModel, UserRoleSetBindingModel, UserRoleListViewModel, UserRoleViewModel, UserRoleBusinessLogic>,
		IGenericControlEntityElement
	{
		public ControlUserRoleElement()
		{
			InitializeComponent();
			Title = "Связи пользователей с ролями";
			ControlId = new Guid("c5748925-c8ec-4d06-a256-c72b0983d332");
			_genericControlViewEntityElement = this;
		}

		public IControl GetInstanceGenericControl() => new ControlUserRoleElement() { ControlId = Guid.NewGuid() };

		public ControlViewEntityElementConfiguration GetConfigControl() => new();
	}
}